﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace Schraffur
{
   internal class ColorDialogEx : ColorDialog
   {
      [DllImport("user32.dll")]
      static extern bool SetWindowText(IntPtr hWnd, string lpString);

      private string title = string.Empty;
      private bool titleSet = false;

      public string Title
      {
         get { return title; }
         set
         {
            if (value != null && value != title)
            {
               title = value;
               titleSet = false;
            }
         }
      }

      protected override IntPtr HookProc(IntPtr hWnd, int msg, IntPtr wparam, IntPtr lparam)
      {
         if (!titleSet)
         {
            SetWindowText(hWnd, title);
            titleSet = true;
         }

         return base.HookProc(hWnd, msg, wparam, lparam);
      }
   }
}
